//******************************************************************
//
//	MMC File Select and Bootloader for "LED Game for AVR"
//
//	2007.2.4	KAWAKAMI Yukio
//******************************************************************

typedef	unsigned char	uchar;
typedef	unsigned int	uint;
typedef	unsigned long	ulong;
typedef unsigned short	ushort;

struct FDATE {
	unsigned short	ft_day	 : 5;
	unsigned short	ft_month : 4;
	unsigned short	ft_year	 : 7;
};

struct FTIME {
	unsigned short	ft_sec	: 5;
	unsigned short	ft_min	: 6;
	unsigned short	ft_hour	: 5;
};

struct DIRECTORY {
	uchar	filename[8];
	uchar	ext[3];
	uchar	att;
	uchar	not_use[10];
	struct FTIME	time;
	struct FDATE	date;
	unsigned short	cluster;
	ulong	size;
};

struct FILE_DATA {
	ulong	sec;
	uint	sc;
	uint	cluster;
	ushort	size;
	ushort	p;
};

#define		FAT12		1
#define		FAT16		2

#define		ON	1
#define		OFF	0
#define		TRUE	1
#define		FALSE	0

#define		NOP		asm volatile("nop\n"::)
#define		WDR		asm volatile("wdr\n"::)
#define		SLEEP	asm volatile("sleep\n"::)

#define		SW_PORT	PIND
#define		SW_A	2		// PORTD
#define		SW_B	1
#define		SW_UP	4
#define		SW_DN	7
#define		SW_L	5
#define		SW_R	6

#define		SP_OUT	0		// PORTD

#define		LED_PORT	PORTB
#define		LED_DATA	2	// PORTB
#define		LED_CLOCK	0
#define		LED_LATCH	1

#define		MMC_CS		3	// PORTD
#define		MMC_MISO	4	// PORTB
#define		MMC_MOSI	3
#define		MMC_SCK		5

#define		MMC_CS_ON	PORTD &= ~(1<<MMC_CS)
#define		MMC_CS_OFF	PORTD |= (1<<MMC_CS)

#define ADRS3000H	__attribute__ ((section (".bootsub")))


// MakefilẽJIvV̎w(BOOTFLAGS)ɂA
// ADRS3000H w肵֐ 0x3000`
// ȊO 0x3800`̃u[g̈ɔzu
// ZtvOɕKvȊ֐̓u[g̈ɔzu邱

void putc(uchar x, uchar y, uchar c)	ADRS3000H;
void print(uchar *str)					ADRS3000H;
void cls(void)							ADRS3000H;
void LED_set(uchar x, uchar y)			ADRS3000H;
void LED_send_word(ushort data)			ADRS3000H;

void wait_switch_off(void)				ADRS3000H;

uchar SPI_in(void);
void SPI_out(uchar data);

uchar SPI_command(uchar com, ulong arg);
uchar SPI_read_open(ulong adrs);
void SPI_read_close(void);

uchar read_VFAT_info(void)				ADRS3000H;
uchar read_32(ulong addr, uchar *buff)	ADRS3000H;

uchar mmc_read(ulong addr);
uchar mmc_init(void)					ADRS3000H;

ulong cluster_to_adrs(uint cluster);
uint next_cluster(uint c);
uint read_word(ulong addr);

void open_file(struct DIRECTORY *dir, struct FILE_DATA *fd) ADRS3000H;
void next_sector(struct FILE_DATA *fd);
uchar check_file(struct DIRECTORY *dir)			ADRS3000H;
int search_file(struct DIRECTORY *dir, int max) ADRS3000H;

int main(void)							ADRS3000H;
void start_game(void)					ADRS3000H;
uchar spm_main(struct FILE_DATA *fd);
